Merge branch 'tr/valgrind-test-fix'
[git.git] / t / test-lib.sh
blob9802b0b0e99dfb9019c9839a040b6f54fe040ea0
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
30 if test -z "$TEST_OUTPUT_DIRECTORY"
31 then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38 ################################################################
39 # It appears that people try to run tests without building...
40 "$GIT_BUILD_DIR/git" >/dev/null
41 if test $? != 1
42 then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
47 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48 export PERL_PATH SHELL_PATH
50 # if --tee was passed, write the output not only to the terminal, but
51 # additionally to the file test-results/$BASENAME.out, too.
52 case "$GIT_TEST_TEE_STARTED, $* " in
53 done,*)
54 # do not redirect again
56 *' --tee '*|*' --va'*)
57 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
58 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
64 esac
66 # For repeatability, reset the environment to known value.
67 LANG=C
68 LC_ALL=C
69 PAGER=cat
70 TZ=UTC
71 TERM=dumb
72 export LANG LC_ALL PAGER TERM TZ
73 EDITOR=:
74 # A call to "unset" with no arguments causes at least Solaris 10
75 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76 # deriving from the command substitution clustered with the other
77 # ones.
78 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
79 my @env = keys %ENV;
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
88 UNZIP
89 PERF_
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92 print join("\n", @vars);
94 unset XDG_CONFIG_HOME
95 unset GITPERLLIB
96 GIT_AUTHOR_EMAIL=author@example.com
97 GIT_AUTHOR_NAME='A U Thor'
98 GIT_COMMITTER_EMAIL=committer@example.com
99 GIT_COMMITTER_NAME='C O Mitter'
100 GIT_MERGE_VERBOSITY=5
101 GIT_MERGE_AUTOEDIT=no
102 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
103 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
104 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
105 export EDITOR
107 # Add libc MALLOC and MALLOC_PERTURB test
108 # only if we are not executing the test with valgrind
109 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
110 test -n "$TEST_NO_MALLOC_CHECK"
111 then
112 setup_malloc_check () {
113 : nothing
115 teardown_malloc_check () {
116 : nothing
118 else
119 setup_malloc_check () {
120 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
121 export MALLOC_CHECK_ MALLOC_PERTURB_
123 teardown_malloc_check () {
124 unset MALLOC_CHECK_ MALLOC_PERTURB_
128 # Protect ourselves from common misconfiguration to export
129 # CDPATH into the environment
130 unset CDPATH
132 unset GREP_OPTIONS
133 unset UNZIP
135 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
136 1|2|true)
137 echo "* warning: Some tests will not work if GIT_TRACE" \
138 "is set as to trace on STDERR ! *"
139 echo "* warning: Please set GIT_TRACE to something" \
140 "other than 1, 2 or true ! *"
142 esac
144 # Convenience
146 # A regexp to match 5 and 40 hexdigits
147 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
148 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
150 # Zero SHA-1
151 _z40=0000000000000000000000000000000000000000
153 # Line feed
154 LF='
157 export _x05 _x40 _z40 LF
159 # Each test should start with something like this, after copyright notices:
161 # test_description='Description of this test...
162 # This test checks if command xyzzy does the right thing...
164 # . ./test-lib.sh
165 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
166 TERM=$ORIGINAL_TERM &&
167 export TERM &&
168 [ -t 1 ] &&
169 tput bold >/dev/null 2>&1 &&
170 tput setaf 1 >/dev/null 2>&1 &&
171 tput sgr0 >/dev/null 2>&1
172 ) &&
173 color=t
175 while test "$#" -ne 0
177 case "$1" in
178 -d|--d|--de|--deb|--debu|--debug)
179 debug=t; shift ;;
180 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
181 immediate=t; shift ;;
182 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
183 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
184 -h|--h|--he|--hel|--help)
185 help=t; shift ;;
186 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
187 verbose=t; shift ;;
188 --verbose-only=*)
189 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
190 shift ;;
191 -q|--q|--qu|--qui|--quie|--quiet)
192 # Ignore --quiet under a TAP::Harness. Saying how many tests
193 # passed without the ok/not ok details is always an error.
194 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
195 --with-dashes)
196 with_dashes=t; shift ;;
197 --no-color)
198 color=; shift ;;
199 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
200 valgrind=memcheck
201 shift ;;
202 --valgrind=*)
203 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
204 shift ;;
205 --valgrind-only=*)
206 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
207 shift ;;
208 --tee)
209 shift ;; # was handled already
210 --root=*)
211 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
214 echo "error: unknown test option '$1'" >&2; exit 1 ;;
215 esac
216 done
218 if test -n "$valgrind_only"
219 then
220 test -z "$valgrind" && valgrind=memcheck
221 test -z "$verbose" && verbose_only="$valgrind_only"
222 elif test -n "$valgrind"
223 then
224 verbose=t
227 if test -n "$color"
228 then
229 say_color () {
231 TERM=$ORIGINAL_TERM
232 export TERM
233 case "$1" in
234 error)
235 tput bold; tput setaf 1;; # bold red
236 skip)
237 tput setaf 4;; # blue
238 warn)
239 tput setaf 3;; # brown/yellow
240 pass)
241 tput setaf 2;; # green
242 info)
243 tput setaf 6;; # cyan
245 test -n "$quiet" && return;;
246 esac
247 shift
248 printf "%s" "$*"
249 tput sgr0
250 echo
253 else
254 say_color() {
255 test -z "$1" && test -n "$quiet" && return
256 shift
257 printf "%s\n" "$*"
261 error () {
262 say_color error "error: $*"
263 GIT_EXIT_OK=t
264 exit 1
267 say () {
268 say_color info "$*"
271 test "${test_description}" != "" ||
272 error "Test script did not set test_description."
274 if test "$help" = "t"
275 then
276 echo "$test_description"
277 exit 0
280 exec 5>&1
281 exec 6<&0
282 if test "$verbose" = "t"
283 then
284 exec 4>&2 3>&1
285 else
286 exec 4>/dev/null 3>/dev/null
289 test_failure=0
290 test_count=0
291 test_fixed=0
292 test_broken=0
293 test_success=0
295 test_external_has_tap=0
297 die () {
298 code=$?
299 if test -n "$GIT_EXIT_OK"
300 then
301 exit $code
302 else
303 echo >&5 "FATAL: Unexpected exit with code $code"
304 exit 1
308 GIT_EXIT_OK=
309 trap 'die' EXIT
311 # The user-facing functions are loaded from a separate file so that
312 # test_perf subshells can have them too
313 . "$TEST_DIRECTORY/test-lib-functions.sh"
315 # You are not expected to call test_ok_ and test_failure_ directly, use
316 # the test_expect_* functions instead.
318 test_ok_ () {
319 test_success=$(($test_success + 1))
320 say_color "" "ok $test_count - $@"
323 test_failure_ () {
324 test_failure=$(($test_failure + 1))
325 say_color error "not ok $test_count - $1"
326 shift
327 echo "$@" | sed -e 's/^/# /'
328 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
331 test_known_broken_ok_ () {
332 test_fixed=$(($test_fixed+1))
333 say_color error "ok $test_count - $@ # TODO known breakage vanished"
336 test_known_broken_failure_ () {
337 test_broken=$(($test_broken+1))
338 say_color warn "not ok $test_count - $@ # TODO known breakage"
341 test_debug () {
342 test "$debug" = "" || eval "$1"
345 match_pattern_list () {
346 arg="$1"
347 shift
348 test -z "$*" && return 1
349 for pattern_
351 case "$arg" in
352 $pattern_)
353 return 0
354 esac
355 done
356 return 1
359 maybe_teardown_verbose () {
360 test -z "$verbose_only" && return
361 exec 4>/dev/null 3>/dev/null
362 verbose=
365 last_verbose=t
366 maybe_setup_verbose () {
367 test -z "$verbose_only" && return
368 if match_pattern_list $test_count $verbose_only
369 then
370 exec 4>&2 3>&1
371 # Emit a delimiting blank line when going from
372 # non-verbose to verbose. Within verbose mode the
373 # delimiter is printed by test_expect_*. The choice
374 # of the initial $last_verbose is such that before
375 # test 1, we do not print it.
376 test -z "$last_verbose" && echo >&3 ""
377 verbose=t
378 else
379 exec 4>/dev/null 3>/dev/null
380 verbose=
382 last_verbose=$verbose
385 maybe_teardown_valgrind () {
386 test -z "$GIT_VALGRIND" && return
387 GIT_VALGRIND_ENABLED=
390 maybe_setup_valgrind () {
391 test -z "$GIT_VALGRIND" && return
392 if test -z "$valgrind_only"
393 then
394 GIT_VALGRIND_ENABLED=t
395 return
397 GIT_VALGRIND_ENABLED=
398 if match_pattern_list $test_count $valgrind_only
399 then
400 GIT_VALGRIND_ENABLED=t
404 test_eval_ () {
405 # This is a separate function because some tests use
406 # "return" to end a test_expect_success block early.
407 eval </dev/null >&3 2>&4 "$*"
410 test_run_ () {
411 test_cleanup=:
412 expecting_failure=$2
413 setup_malloc_check
414 test_eval_ "$1"
415 eval_ret=$?
416 teardown_malloc_check
418 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
419 then
420 setup_malloc_check
421 test_eval_ "$test_cleanup"
422 teardown_malloc_check
424 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
425 then
426 echo ""
428 return "$eval_ret"
431 test_start_ () {
432 test_count=$(($test_count+1))
433 maybe_setup_verbose
434 maybe_setup_valgrind
437 test_finish_ () {
438 echo >&3 ""
439 maybe_teardown_valgrind
440 maybe_teardown_verbose
443 test_skip () {
444 to_skip=
445 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
446 then
447 to_skip=t
449 if test -z "$to_skip" && test -n "$test_prereq" &&
450 ! test_have_prereq "$test_prereq"
451 then
452 to_skip=t
454 case "$to_skip" in
456 of_prereq=
457 if test "$missing_prereq" != "$test_prereq"
458 then
459 of_prereq=" of $test_prereq"
462 say_color skip >&3 "skipping test: $@"
463 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
464 : true
467 false
469 esac
472 # stub; perf-lib overrides it
473 test_at_end_hook_ () {
477 test_done () {
478 GIT_EXIT_OK=t
480 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
481 # output file
482 if test -z "$HARNESS_ACTIVE"
483 then
484 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
485 mkdir -p "$test_results_dir"
486 base=${0##*/}
487 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
489 cat >>"$test_results_path" <<-EOF
490 total $test_count
491 success $test_success
492 fixed $test_fixed
493 broken $test_broken
494 failed $test_failure
499 if test "$test_fixed" != 0
500 then
501 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
503 if test "$test_broken" != 0
504 then
505 say_color warn "# still have $test_broken known breakage(s)"
507 if test "$test_broken" != 0 || test "$test_fixed" != 0
508 then
509 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
510 msg="remaining $test_remaining test(s)"
511 else
512 test_remaining=$test_count
513 msg="$test_count test(s)"
515 case "$test_failure" in
517 # Maybe print SKIP message
518 if test -n "$skip_all" && test $test_count -gt 0
519 then
520 error "Can't use skip_all after running some tests"
522 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
524 if test $test_external_has_tap -eq 0
525 then
526 if test $test_remaining -gt 0
527 then
528 say_color pass "# passed all $msg"
530 say "1..$test_count$skip_all"
533 test -d "$remove_trash" &&
534 cd "$(dirname "$remove_trash")" &&
535 rm -rf "$(basename "$remove_trash")"
537 test_at_end_hook_
539 exit 0 ;;
542 if test $test_external_has_tap -eq 0
543 then
544 say_color error "# failed $test_failure among $msg"
545 say "1..$test_count"
548 exit 1 ;;
550 esac
553 if test -n "$valgrind"
554 then
555 make_symlink () {
556 test -h "$2" &&
557 test "$1" = "$(readlink "$2")" || {
558 # be super paranoid
559 if mkdir "$2".lock
560 then
561 rm -f "$2" &&
562 ln -s "$1" "$2" &&
563 rm -r "$2".lock
564 else
565 while test -d "$2".lock
567 say "Waiting for lock on $2."
568 sleep 1
569 done
574 make_valgrind_symlink () {
575 # handle only executables, unless they are shell libraries that
576 # need to be in the exec-path. We will just use "#!" as a
577 # guess for a shell-script, since we have no idea what the user
578 # may have configured as the shell path.
579 test -x "$1" ||
580 test "#!" = "$(head -c 2 <"$1")" ||
581 return;
583 base=$(basename "$1")
584 symlink_target=$GIT_BUILD_DIR/$base
585 # do not override scripts
586 if test -x "$symlink_target" &&
587 test ! -d "$symlink_target" &&
588 test "#!" != "$(head -c 2 < "$symlink_target")"
589 then
590 symlink_target=../valgrind.sh
592 case "$base" in
593 *.sh|*.perl)
594 symlink_target=../unprocessed-script
595 esac
596 # create the link, or replace it if it is out of date
597 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
600 # override all git executables in TEST_DIRECTORY/..
601 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
602 mkdir -p "$GIT_VALGRIND"/bin
603 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
605 make_valgrind_symlink $file
606 done
607 # special-case the mergetools loadables
608 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
609 OLDIFS=$IFS
610 IFS=:
611 for path in $PATH
613 ls "$path"/git-* 2> /dev/null |
614 while read file
616 make_valgrind_symlink "$file"
617 done
618 done
619 IFS=$OLDIFS
620 PATH=$GIT_VALGRIND/bin:$PATH
621 GIT_EXEC_PATH=$GIT_VALGRIND/bin
622 export GIT_VALGRIND
623 GIT_VALGRIND_MODE="$valgrind"
624 export GIT_VALGRIND_MODE
625 GIT_VALGRIND_ENABLED=t
626 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
627 export GIT_VALGRIND_ENABLED
628 elif test -n "$GIT_TEST_INSTALLED"
629 then
630 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
631 error "Cannot run git from $GIT_TEST_INSTALLED."
632 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
633 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
634 else # normal case, use ../bin-wrappers only unless $with_dashes:
635 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
636 if ! test -x "$git_bin_dir/git"
637 then
638 if test -z "$with_dashes"
639 then
640 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
642 with_dashes=t
644 PATH="$git_bin_dir:$PATH"
645 GIT_EXEC_PATH=$GIT_BUILD_DIR
646 if test -n "$with_dashes"
647 then
648 PATH="$GIT_BUILD_DIR:$PATH"
651 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
652 unset GIT_CONFIG
653 GIT_CONFIG_NOSYSTEM=1
654 GIT_ATTR_NOSYSTEM=1
655 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
657 if test -z "$GIT_TEST_CMP"
658 then
659 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
660 then
661 GIT_TEST_CMP="$DIFF -c"
662 else
663 GIT_TEST_CMP="$DIFF -u"
667 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
668 export GITPERLLIB
669 test -d "$GIT_BUILD_DIR"/templates/blt || {
670 error "You haven't built things yet, have you?"
673 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
674 then
675 echo >&2 'You need to build test-chmtime:'
676 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
677 exit 1
680 # Test repository
681 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
682 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
683 case "$TRASH_DIRECTORY" in
684 /*) ;; # absolute path is good
685 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
686 esac
687 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
688 rm -fr "$TRASH_DIRECTORY" || {
689 GIT_EXIT_OK=t
690 echo >&5 "FATAL: Cannot prepare test area"
691 exit 1
694 HOME="$TRASH_DIRECTORY"
695 export HOME
697 if test -z "$TEST_NO_CREATE_REPO"
698 then
699 test_create_repo "$TRASH_DIRECTORY"
700 else
701 mkdir -p "$TRASH_DIRECTORY"
703 # Use -P to resolve symlinks in our working directory so that the cwd
704 # in subprocesses like git equals our $PWD (for pathname comparisons).
705 cd -P "$TRASH_DIRECTORY" || exit 1
707 this_test=${0##*/}
708 this_test=${this_test%%-*}
709 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
710 then
711 say_color info >&3 "skipping test $this_test altogether"
712 skip_all="skip all tests in $this_test"
713 test_done
716 # Provide an implementation of the 'yes' utility
717 yes () {
718 if test $# = 0
719 then
721 else
722 y="$*"
725 while echo "$y"
728 done
731 # Fix some commands on Windows
732 case $(uname -s) in
733 *MINGW*)
734 # Windows has its own (incompatible) sort and find
735 sort () {
736 /usr/bin/sort "$@"
738 find () {
739 /usr/bin/find "$@"
741 sum () {
742 md5sum "$@"
744 # git sees Windows-style pwd
745 pwd () {
746 builtin pwd -W
748 # no POSIX permissions
749 # backslashes in pathspec are converted to '/'
750 # exec does not inherit the PID
751 test_set_prereq MINGW
752 test_set_prereq NOT_CYGWIN
753 test_set_prereq SED_STRIPS_CR
754 test_set_prereq GREP_STRIPS_CR
756 *CYGWIN*)
757 test_set_prereq POSIXPERM
758 test_set_prereq EXECKEEPSPID
759 test_set_prereq NOT_MINGW
760 test_set_prereq CYGWIN
761 test_set_prereq SED_STRIPS_CR
762 test_set_prereq GREP_STRIPS_CR
765 test_set_prereq POSIXPERM
766 test_set_prereq BSLASHPSPEC
767 test_set_prereq EXECKEEPSPID
768 test_set_prereq NOT_MINGW
769 test_set_prereq NOT_CYGWIN
771 esac
773 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
774 test -z "$NO_PERL" && test_set_prereq PERL
775 test -z "$NO_PYTHON" && test_set_prereq PYTHON
776 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
777 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
779 # Can we rely on git's output in the C locale?
780 if test -n "$GETTEXT_POISON"
781 then
782 GIT_GETTEXT_POISON=YesPlease
783 export GIT_GETTEXT_POISON
784 test_set_prereq GETTEXT_POISON
785 else
786 test_set_prereq C_LOCALE_OUTPUT
789 # Use this instead of test_cmp to compare files that contain expected and
790 # actual output from git commands that can be translated. When running
791 # under GETTEXT_POISON this pretends that the command produced expected
792 # results.
793 test_i18ncmp () {
794 test -n "$GETTEXT_POISON" || test_cmp "$@"
797 # Use this instead of "grep expected-string actual" to see if the
798 # output from a git command that can be translated either contains an
799 # expected string, or does not contain an unwanted one. When running
800 # under GETTEXT_POISON this pretends that the command produced expected
801 # results.
802 test_i18ngrep () {
803 if test -n "$GETTEXT_POISON"
804 then
805 : # pretend success
806 elif test "x!" = "x$1"
807 then
808 shift
809 ! grep "$@"
810 else
811 grep "$@"
815 test_lazy_prereq PIPE '
816 # test whether the filesystem supports FIFOs
817 case $(uname -s) in
818 CYGWIN*)
819 false
822 rm -f testfifo && mkfifo testfifo
824 esac
827 test_lazy_prereq SYMLINKS '
828 # test whether the filesystem supports symbolic links
829 ln -s x y && test -h y
832 test_lazy_prereq CASE_INSENSITIVE_FS '
833 echo good >CamelCase &&
834 echo bad >camelcase &&
835 test "$(cat CamelCase)" != good
838 test_lazy_prereq UTF8_NFD_TO_NFC '
839 # check whether FS converts nfd unicode to nfc
840 auml=$(printf "\303\244")
841 aumlcdiar=$(printf "\141\314\210")
842 >"$auml" &&
843 case "$(echo *)" in
844 "$aumlcdiar")
845 true ;;
847 false ;;
848 esac
851 test_lazy_prereq AUTOIDENT '
852 sane_unset GIT_AUTHOR_NAME &&
853 sane_unset GIT_AUTHOR_EMAIL &&
854 git var GIT_AUTHOR_IDENT
857 # When the tests are run as root, permission tests will report that
858 # things are writable when they shouldn't be.
859 test -w / || test_set_prereq SANITY
861 GIT_UNZIP=${GIT_UNZIP:-unzip}
862 test_lazy_prereq UNZIP '
863 "$GIT_UNZIP" -v
864 test $? -ne 127